import {
  encodeContext
} from "./../../helpers/composables.js";
import { performRequest } from "./index.js";
export function useGraphqlMutation(...args) {
  const [name, body, fetchOptions = {}, clientContext = {}] = typeof args[0] === "string" ? [args[0], args[1], args[2]?.fetchOptions, args[2]?.clientContext] : [
    args[0].name,
    args[0].variables,
    args[0].fetchOptions,
    args[0].clientContext
  ];
  return performRequest("mutation", name, "post", {
    ...fetchOptions,
    body,
    params: {
      ...encodeContext(clientContext),
      ...fetchOptions.params || {}
    }
  });
}
